import { useEffect, useState } from "react";
import { useNavigate, useParams } from "react-router-dom";

function EditUser() {
  const {id}=useParams();
  const [user, setUser]=useState({nom:"",email:"",password:""});
  const [error, setError]=useState("");
  const goTo = useNavigate()
  const handleSubmit=(e)=>{
    e.preventDefault();
    setError("");
    fetch(id?"http://localhost:3001/api/users/"+id: "http://localhost:3001/api/users",{
      headers:{
        "Content-Type":"application/json",
        Authorization : `Bearer ${sessionStorage.getItem('sessionToken')}`
      },
      method:id? "PUT":"POST",
      body:JSON.stringify(user)
    }).then(async (res)=>{
      if(!res.ok){
        const data=await res.json();
        setError(data.error || "Erreur!");
      }else{
        const data=await res.json();
        if(data.success)
          goTo("/dashboard/list-users");
      }

    }).catch((err)=>{
        setError("Erreur lors de la connexion à l'API!");
    });
  }
  useEffect(()=>{
    if(id){
      fetch(`http://localhost:3001/api/users/${id}`,{
        headers:{
          "Content-Type":"application/json",
          Authorization : `Bearer ${sessionStorage.getItem('sessionToken')}`
        },
        method:"GET"
      }).then(async (res)=>{
        if(!res.ok){
          const data=await res.json();
          setError(data.error || "Erreur!");
        }else{
          const data=await res.json();
          if(data[0])
            setUser(data[0]);
        }

      }).catch((err)=>{
          setError("Erreur lors de la connexion à l'API!");
      });
    }
  },[])
  return (
    <main className="main-content  mt-0">
    <section>
      <div className="page-header min-vh-75">
        <div className="container">
          <div className="row">
            <div className="col-md-8 d-flex flex-column mx-auto">
              <div className="card card-plain">
                <div className="card-header pb-0 text-left bg-transparent">
                  <h3 className="font-weight-bolder text-info text-gradient">Edition Utilisateur</h3>
                </div>
                <div className="card-body">
                <p className="mb-0" style={{color:"red"}}>{error}</p>
                  <form role="form" onSubmit={handleSubmit}>
                    <label>Nom</label>
                    <div className="mb-3">
                      <input type="text" className="form-control" placeholder="Nom" aria-label="Nom" aria-describedby="nom-addon" value={user.nom} onChange={(e)=>setUser({nom:e.target.value, email:user.email,password:user.password})}/>
                    </div>
                    <label>Email</label>
                    <div className="mb-3">
                      <input type="email" className="form-control" placeholder="Email" aria-label="Email" aria-describedby="email-addon" value={user.email} onChange={(e)=>setUser({...user,email:e.target.value})}/>
                    </div>
                    <label>Password</label>
                    <div className="mb-3">
                      <input type="password" className="form-control" placeholder="Password" aria-label="Password" aria-describedby="password-addon" value={user.password} onChange={(e)=>setUser({...user,password:e.target.value})}/>
                    </div>
                    <div className="text-center">
                      <button type="submit" className="btn bg-gradient-info w-100 mt-4 mb-0">Enregistrer</button>
                    </div>
                  </form>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
  </main>
  );
}

export default EditUser;
