import { useEffect, useState } from "react";
import { useNavigate } from "react-router-dom";

function ListUsers() {
  const [error, setError]=useState("");
  const [users, setUsers]=useState([]);
  const goTo = useNavigate();

  const editUser = (id)=>{
    goTo(`/dashboard/edit-user/${id}`);
  }

  useEffect(()=>{
    fetch("http://localhost:3001/api/users",{
      headers:{
        "Content-Type":"application/json",
        Authorization : `Bearer ${sessionStorage.getItem('sessionToken')}`
      },
      method:"GET"
    }).then(async (res)=>{
      if(!res.ok){
        const data=await res.json();
        setError(data.error || "Erreur!");
      }else{
        const data=await res.json();
        setUsers(data);
      }

    }).catch((err)=>{
        setError("Erreur lors de la connexion à l'API!");
    });
  }, [])

  return (
    <div>
    <h2>
    ListUsers
    </h2>
    <p style={{color:'red'}}>{error}</p>
    <div className="card-body px-0 pb-2">
      <div className="table-responsive">
        <table className="table align-items-center mb-0">
          <thead>
            <tr>
              <th className="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">Nom</th>
              <th className="text-uppercase text-secondary text-xxs font-weight-bolder opacity-7 ps-2">Email</th>
              <th className="text-center text-uppercase text-secondary text-xxs font-weight-bolder opacity-7">Actions</th>
            </tr>
          </thead>
          <tbody>
            {users.map((u)=>(
              <tr key={u.id}><td>{u.nom}</td><td>{u.email}</td>
                <td>
                <button className="btn btn-primary px-3" onClick={()=>{editUser(u.id)}}>Modifier</button>
                </td>
              </tr>
            ))}
          </tbody>
        </table>
      </div>
    </div>

    </div>
  );
}

export default ListUsers;
